(function ($, Drupal, drupalSettings) {
  Drupal.behaviors.sign_widget = {
    attach: function (context) {
      $(".signature-pad", context).once("initiate-signature-pad").each(function () {
        function resizeCanvas(canvas) {
          let ratio = Math.max(window.devicePixelRatio || 1, 1);
          canvas.width = canvas.offsetWidth * ratio;
          canvas.height = canvas.offsetHeight * ratio;
          canvas.getContext("2d").scale(ratio, ratio);
        }
        $("canvas.signature-pad").each(function (index) {
          let setting_pad = $(this).data();
          let index_pad = $(this).attr('id');
          let canvas = document.getElementById(index_pad);
          let background = '';
          // Assign the hidden field (that saves the signature) to a variable.
          background = $(this).closest('.signature_panel').find(".background");
          // Instantiate the signaturepad itself.
          setting_pad.onEnd = function () {
            // When a signature is done being signed, set the hidden field to contain the data.
            $('#' + index_pad + '-sign').val(window[index_pad].toDataURL('image/png'));
          };
          window[index_pad] = new SignaturePad(canvas, setting_pad);
          if (background) {
            window[index_pad].fromDataURL(background.attr('src'));
          }
          window.addEventListener("resize", function () {
            resizeCanvas(canvas);
          });
        });
        $('.signature_panel .clear').on('click', function () {
          let index_pad = $(this).data('id');
          window[index_pad].clear();
          $(this).closest('.esign_container').find(".signature-storage").val('');
        });

        $('.signature_panel .toolbox input').on('change', function () {
          let index_pad = $(this).data('id');
          let type = $(this).data('type');
          window[index_pad][type] = $(this).val();
          $('#' + index_pad).data(type, $(this).val());
          if (type == 'dotSize') {
            window[index_pad].maxWidth = $(this).val();
            $('#' + index_pad).data('maxWidth', $(this).val());
          }
        });
      });
    }
  };
}(jQuery, Drupal));
